# PhasicFlow: List< T > Class Template Reference

List< T > Class Template Reference
Inheritance diagram for List< T >:
[legend]
Collaboration diagram for List< T >:
[legend]

## Public Types

using | ListType = List< T >
using | listType = std::list< T, std::allocator< T > >
using | iterator = typename listType::iterator
using | constIterator = typename listType::const_iterator
using | reference = typename listType::reference
using | constReference = typename listType::const_reference
using | initList = typename std::initializer_list< T >
using | valueType = T

## Public Member Functions

| TypeInfoTemplateNV ("List", T)
| List ()
| List (size_t len)
| List (size_t len, const T &value)
| List (initList lst)
| List (const List &src)
| List (List &&mv)
ListType & | operator= (const ListType &rhs)
ListType & | operator= (ListType &&rhs)
uniquePtr< ListType > | clone () const
ListType * | clonePtr () const
| ~List ()
int32 | countElement (const T &elm) const
size_t | size () const
T & | operator[] (size_t i)
const T & | operator[] (size_t i) const
constIterator | find (const T &val) const
iterator | find (const T &val)
int32 | findi (const T &val) const
bool | search (const T &val) const
void | set (size_t i, const T &val)
void | set (size_t i, T &&val)
bool | writeList (iOstream &os) const
bool | readList (iIstream &is)
bool | read (iIstream &is)
bool | write (iOstream &os) const

## Protected Member Functions

auto | pos (size_t i)
const auto | pos (size_t i) const

## Static Protected Member Functions

static size_t | getListStride (const size_t &len)

## Detailed Description

### template<typename T>
class pFlow::List< T >

Definition at line 39 of file List.hpp.

## Member Typedef Documentation

## ListType

using ListType = List<T>

Definition at line 46 of file List.hpp.

## listType

using listType = std::list<T,std::allocator<T> >

Definition at line 48 of file List.hpp.

## iterator

using iterator = typename listType::iterator

Definition at line 50 of file List.hpp.

## constIterator

using constIterator = typename listType::const_iterator

Definition at line 52 of file List.hpp.

## reference

using reference = typename listType::reference

Definition at line 54 of file List.hpp.

## constReference

using constReference = typename listType::const_reference

Definition at line 56 of file List.hpp.

## initList

using initList = typename std::initializer_list<T>

Definition at line 58 of file List.hpp.

## valueType

using valueType = T

Definition at line 60 of file List.hpp.

## Constructor & Destructor Documentation

## List() [1/6]

List | ( |  | ) |

inline

Definition at line 94 of file List.hpp.

## List() [2/6]

List | ( | size_t | len | ) |

inline

Definition at line 98 of file List.hpp.

## List() [3/6]

List | ( | size_t | len,
|  | const T & | value
| ) |  |

inline

Definition at line 104 of file List.hpp.

## List() [4/6]

List | ( | initList< T > | lst | ) |

inline

Definition at line 110 of file List.hpp.

## List() [5/6]

List | ( | const List< T > & | src | ) |

inline

Definition at line 117 of file List.hpp.

## List() [6/6]

List | ( | List< T > && | mv | ) |

inline

Definition at line 122 of file List.hpp.

## ~List()

~List | ( |  | ) |

inline

Definition at line 152 of file List.hpp.

## Member Function Documentation

## pos() [1/2]

auto pos | ( | size_t | i | ) |

protected

Definition at line 23 of file ListI.hpp.

## pos() [2/2]

const auto pos | ( | size_t | i | ) | const

protected

Definition at line 40 of file ListI.hpp.

## getListStride()

static size_t getListStride | ( | const size_t & | len | ) |

inlinestaticprotected

Definition at line 71 of file List.hpp.

## TypeInfoTemplateNV()

TypeInfoTemplateNV | ( | "List< T >" | ,
|  | T |
| ) |  |

## operator=() [1/2]

ListType& operator= | ( | const ListType & | rhs | ) |

inline

Definition at line 128 of file List.hpp.

## operator=() [2/2]

ListType& operator= | ( | ListType && | rhs | ) |

inline

Definition at line 135 of file List.hpp.

## clone()

uniquePtr<ListType> clone | ( |  | ) | const

inline

Definition at line 142 of file List.hpp.

## clonePtr()

ListType* clonePtr | ( |  | ) | const

inline

Definition at line 146 of file List.hpp.

## countElement()

pFlow::int32 countElement | ( | const T & | elm | ) | const

inline

Definition at line 58 of file ListI.hpp.

## size()

size_t size

inline

Definition at line 66 of file ListI.hpp.

Referenced by positionOrdered::findAxisIndex().

Here is the caller graph for this function:

## operator[]() [1/2]

T & operator[] | ( | size_t | i | ) |

inline

Definition at line 73 of file ListI.hpp.

## operator[]() [2/2]

const T & operator[] | ( | size_t | i | ) | const

inline

Definition at line 82 of file ListI.hpp.

## find() [1/2]

pFlow::List< T >::constIterator find | ( | const T & | val | ) | const

inline

Definition at line 92 of file ListI.hpp.

Referenced by Timers::removeFromList().

Here is the caller graph for this function:

## find() [2/2]

pFlow::List< T >::iterator find | ( | const T & | val | ) |

inline

Definition at line 101 of file ListI.hpp.

## findi()

pFlow::int32 findi | ( | const T & | val | ) | const

Definition at line 109 of file ListI.hpp.

Referenced by rotatingAxisMotion::nameToIndex(), vibratingMotion::nameToIndex(), and multiRotatingAxisMotion::nameToIndex().

Here is the caller graph for this function:

## search()

bool search | ( | const T & | val | ) | const

Definition at line 118 of file ListI.hpp.

## set() [1/2]

void set | ( | size_t | i,
|  | const T & | val
| ) |  |

inline

Definition at line 128 of file ListI.hpp.

## set() [2/2]

void set | ( | size_t | i,
|  | T && | val
| ) |  |

inline

Definition at line 135 of file ListI.hpp.

## writeList()

bool writeList | ( | iOstream & | os | ) | const

inline

Definition at line 144 of file ListI.hpp.

Referenced by List< word >::write().

Here is the caller graph for this function:

## readList()

bool readList | ( | iIstream & | is | ) |

inline

Definition at line 178 of file ListI.hpp.

Referenced by List< word >::read().

Here is the caller graph for this function:

## read()

bool read | ( | iIstream & | is | ) |

inline

Definition at line 206 of file List.hpp.

## write()

bool write | ( | iOstream & | os | ) | const

inline

Definition at line 211 of file List.hpp.

The documentation for this class was generated from the following files:

- src/phasicFlow/containers/List/List/List.hpp
- src/phasicFlow/containers/List/List/ListI.hpp